> For the complete documentation index, see [llms.txt](https://docs.rasgoml.com/rasgo-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rasgoml.com/rasgo-docs/rasgo-0.1/all-transforms/sliding_slope.md).

# Sliding Slope

Calculates the linear slope on a given row, looking backwards for a user-defined window of periods.

Pass in a partition\_col, an order\_col, and a lookback window size.

NOTE: Your data should be a properly formatted timeseries dataset before applying this transformation. In other words, each period should only appear once, and periods considered zero should be imputed with 0 already. NOTE: Slope calculations are notoriously sensitive to large outliers, especially with smaller windows.

Example use case: On daily stock data, calculate SLOPE by TICKER, with a 14-period lookback window.

## Parameters

| Name           | Type   | Description                                                                                   | Is Optional |
| -------------- | ------ | --------------------------------------------------------------------------------------------- | ----------- |
| partition\_col | column | Grouping column to calculate the slope within.                                                |             |
| order\_col     | column | Column to order rows by when calculating the agg window. Slope automatically sorts ascending. |             |
| value\_col     | column | Column to calulate slope for.                                                                 |             |
| window         | int    | Number of periods to use as a lookback period, to calculate slope.                            |             |

## Example

```python
ds = rasgo.get.dataset(fqtn="RASGOCOMMUNITY.PUBLIC.ZEPL_DAILY_STOCK_FEATURES")

ds2 = ds.sliding_slope(partition_col = 'TICKER', 
              order_col = 'DATE', 
              value_col = 'CLOSE', 
              window = 14)

```

## Source Code

{% embed url="<https://github.com/rasgointelligence/RasgoTransforms/blob/main/rasgotransforms/rasgotransforms/transforms/sliding_slope/snowflake/sliding_slope.sql>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rasgoml.com/rasgo-docs/rasgo-0.1/all-transforms/sliding_slope.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
